<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('关联账户名')" prop="username">
        <el-input v-model="queryParams.username" :placeholder="$t('请输入关联账户名')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('区号')" prop="areaCode">
        <el-input v-model="queryParams.areaCode" :placeholder="$t('请输入区号')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('手机号码(不带任何区号)')" prop="phoneNew">
        <el-input v-model="queryParams.phoneNew" :placeholder="$t('请输入手机号码(不带任何区号)')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('创建时间')">
        <el-date-picker v-model="dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" :start-placeholder="$t('开始日期')" :end-placeholder="$t('结束日期')" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:customer-contacts:create']">{{$t('新增')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:customer-contacts:export']">{{$t('导出')}}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column :label="$t('客户id')" align="center" prop="customerId" />
      <el-table-column :label="$t('部门')" align="center" prop="department" />
      <el-table-column :label="$t('职位')" align="center" prop="position" />
      <el-table-column :label="$t('联系人')" align="center" prop="name" />
      <el-table-column :label="$t('联系方式')" align="center" prop="phone" />
      <el-table-column :label="$t('社交方式')" align="center" prop="social" />
      <el-table-column :label="$t('社交软件号码')" align="center" prop="socialNumber" />
      <el-table-column :label="$t('电子邮箱')" align="center" prop="email" />
      <el-table-column :label="$t('默认联系人：1为默认')" align="center" prop="default" />
      <el-table-column :label="$t('关联账户id')" align="center" prop="userid" />
      <el-table-column :label="$t('关联账户名')" align="center" prop="username" />
      <el-table-column :label="$t('区号')" align="center" prop="areaCode" />
      <el-table-column :label="$t('手机号码(不带任何区号)')" align="center" prop="phoneNew" />
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:customer-contacts:update']">{{$t('修改')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:customer-contacts:delete']">{{$t('删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('客户id')" prop="customerId">
          <el-input v-model="form.customerId" :placeholder="$t('请输入客户id')" />
        </el-form-item>
        <el-form-item :label="$t('部门')" prop="department">
          <el-input v-model="form.department" :placeholder="$t('请输入部门')" />
        </el-form-item>
        <el-form-item :label="$t('职位')" prop="position">
          <el-input v-model="form.position" :placeholder="$t('请输入职位')" />
        </el-form-item>
        <el-form-item :label="$t('联系人')" prop="name">
          <el-input v-model="form.name" :placeholder="$t('请输入联系人')" />
        </el-form-item>
        <el-form-item :label="$t('联系方式')" prop="phone">
          <el-input v-model="form.phone" :placeholder="$t('请输入联系方式')" />
        </el-form-item>
        <el-form-item :label="$t('社交方式')" prop="social">
          <el-input v-model="form.social" :placeholder="$t('请输入社交方式')" />
        </el-form-item>
        <el-form-item :label="$t('社交软件号码')" prop="socialNumber">
          <el-input v-model="form.socialNumber" :placeholder="$t('请输入社交软件号码')" />
        </el-form-item>
        <el-form-item :label="$t('电子邮箱')" prop="email">
          <el-input v-model="form.email" :placeholder="$t('请输入电子邮箱')" />
        </el-form-item>
        <el-form-item :label="$t('默认联系人：1为默认')" prop="default">
          <el-input v-model="form.default" :placeholder="$t('请输入默认联系人：1为默认')" />
        </el-form-item>
        <el-form-item :label="$t('关联账户id')" prop="userid">
          <el-input v-model="form.userid" :placeholder="$t('请输入关联账户id')" />
        </el-form-item>
        <el-form-item :label="$t('关联账户名')" prop="username">
          <el-input v-model="form.username" :placeholder="$t('请输入关联账户名')" />
        </el-form-item>
        <el-form-item :label="$t('区号')" prop="areaCode">
          <el-input v-model="form.areaCode" :placeholder="$t('请输入区号')" />
        </el-form-item>
        <el-form-item :label="$t('手机号码(不带任何区号)')" prop="phoneNew">
          <el-input v-model="form.phoneNew" :placeholder="$t('请输入手机号码(不带任何区号)')" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{$t('确 定')}}</el-button>
        <el-button @click="cancel">{{$t('取 消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createCustomerContacts, updateCustomerContacts, deleteCustomerContacts, getCustomerContacts, getCustomerContactsPage, exportCustomerContactsExcel } from "@/api/ecw/customerContacts";

export default {
  name: "CustomerContacts",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 客户联系人列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        username: null,
        areaCode: null,
        phoneNew: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        areaCode: [{ required: true, message: this.$t('区号不能为空'), trigger: "blur" }],
        phoneNew: [{ required: true, message: this.$t('手机号码(不带任何区号)不能为空'), trigger: "blur" }],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getCustomerContactsPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        customerId: undefined,
        department: undefined,
        position: undefined,
        name: undefined,
        phone: undefined,
        social: undefined,
        socialNumber: undefined,
        email: undefined,
        default: undefined,
        userid: undefined,
        username: undefined,
        areaCode: undefined,
        phoneNew: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('添加客户联系人');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getCustomerContacts(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改客户联系人');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCustomerContacts(this.form).then(response => {
            this.$modal.msgSuccess(this.$t('修改成功'));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCustomerContacts(this.form).then(response => {
          this.$modal.msgSuccess(this.$t('新增成功'));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除客户联系人编号为"') + id + this.$t('"的数据项?')).then(function() {
          return deleteCustomerContacts(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t('删除成功'));
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有客户联系人数据项?')).then(() => {
          this.exportLoading = true;
          return exportCustomerContactsExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
